package com.diagbot.facade.rule;

import com.diagbot.dto.BillDTO;
import com.diagbot.dto.BillMsg;
import com.diagbot.dto.BillNeoDTO;
import com.diagbot.dto.DrugBillNeoDTO;
import com.diagbot.dto.WordCrfDTO;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;

/**
 * @Description: 规则facade
 * @author: zhoutg
 * @time: 2018/8/6 9:11
 */
@Component
public class BillRuleFacade {

    public BillDTO process(List<BillNeoDTO> billNeoDTOList, WordCrfDTO wordCrfDTO) {
        BillDTO billDTO = new BillDTO();
        // 化验规则处理
        processBillWithLis(billNeoDTOList, wordCrfDTO, billDTO);
        // 辅检规则处理
        processBillWithPacs(billNeoDTOList, wordCrfDTO, billDTO);
        // 药品规则处理
        processBillWithDrug(billNeoDTOList, wordCrfDTO, billDTO);
        return billDTO;
    }

    public void processBillWithLis(List<BillNeoDTO> billNeoDTOList, WordCrfDTO wordCrfDTO, BillDTO billDTO) {

    }

    public void processBillWithPacs(List<BillNeoDTO> billNeoDTOList, WordCrfDTO wordCrfDTO, BillDTO billDTO) {

    }

    public void processBillWithDrug(List<BillNeoDTO> billNeoDTOList, WordCrfDTO wordCrfDTO, BillDTO billDTO) {
        for (BillNeoDTO bill : billNeoDTOList) {
            List<DrugBillNeoDTO> drugBillNeoDTOList = bill.getDrugBillNeoDTOList();
            List<BillMsg> drugBill = new ArrayList<>();
            for (DrugBillNeoDTO drug : drugBillNeoDTOList) {
                // 性别
                BillMsg billMsg = RuleUtil.compareSexWithBill(drug.getGender(), wordCrfDTO, bill.getName());
                if (billMsg != null) {
                    drugBill.add(billMsg);
                }
            }
        }
    }

}
