package com.diagbot.web;

import com.diagbot.dto.BillDTO;
import com.diagbot.dto.RespDTO;
import com.diagbot.facade.BillFacade;
import com.diagbot.facade.PushFacade;
import com.diagbot.vo.IndicationPushVO;
import com.diagbot.vo.PushVO;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @Description: CDSS核心API控制层
 * @author: zhoutg
 * @time: 2018/8/30 10:12
 */
@RestController
@RequestMapping("/core")
@Api(value = "CDSS核心API", tags = { "CDSS核心API" })
@SuppressWarnings("unchecked")
public class CoreController {

    @Autowired
    private BillFacade billFacade;
    @Autowired
    private PushFacade pushFacade;

    @ApiOperation(value = "开单合理性API[zhoutg]", notes = "")
    @PostMapping("/bill")
    public RespDTO<BillDTO> bill(@RequestBody IndicationPushVO indicationPushVO) {
        return RespDTO.onSuc(billFacade.billFac(indicationPushVO));
    }

    @ApiOperation(value = "推送API[zhoutg]", notes = "类型(多选必填)，1：症状，4：查体结果，42：查体指标，5：检验，6：检查，7：诊断")
    @PostMapping("/push")
    public RespDTO<BillDTO> push(@RequestBody PushVO pushVo) {
        return RespDTO.onSuc(pushFacade.pushFac(pushVo));
    }
}

